

var BugReporter = {};

BugReporter.initDoc = function(doc){

    doc = doc || document;

    var radios = doc.getElementsByName('problem');
    
    for (var i=0; i<radios.length; i++){
        Klib.addEvent(radios[i], 'click', BugReporter.focusNextField);
    }
    
    BugReporter.setupToggleEmailFields(doc);
}

BugReporter.focusNextField = function(evt){
    
    //set the focus on the next visible field after the one the user has just clicked on.
    var report = $('bugreporter-form');
    var radio = evt.source;

    for (var i=0; i<(report.elements.length-1); i++){
        var ele = report.elements[i];
        
        if (ele == radio){
            try {
                report.elements[i+1].focus();
            }catch(e){}
            break;
        }
    }
}

BugReporter.setupToggleEmailFields = function(doc){
    var box1 = doc.getElementsByName('emailAboutBug');
    var box2 = doc.getElementsByName('emailWhenFixed');
    
    var boxes = [];
    for (var i=0; i<box1.length; i++){
        boxes.push(box1[i]);
    }
    for (var i=0; i<box2.length; i++){
        boxes.push(box2[i]);
    }
    
    for (var i=0; i<boxes.length; i++){
        var box = boxes[i];
        //get email textbox for this checkbox
        var emailId = box.id.replace(/(emailAboutBug|emailWhenFixed)/i, "Email");
        var email = $(emailId, doc);
        
        if (email){
            box.userEmail = email;
            
            if (box.name == "emailAboutBug"){
                email.emailAboutBug = box;
            }
            else {
                email.emailWhenFixed = box;
            }
            
            email.checkForEnabled = function(evt){
                var textbox = (evt) ? evt.source.userEmail : email;
                textbox.disabled = ((textbox.emailAboutBug && textbox.emailAboutBug.checked) || (textbox.emailWhenFixed && textbox.emailWhenFixed.checked)) ? false : true;
            }
            
            Klib.addEvent(box, "click", email.checkForEnabled);
            email.checkForEnabled();
        }
        else {
            Klib.error("Unable to find email box for checkbox", box.id, emailId);
        }
    }
}
    