

// using IE conditional compilation to detect IE browsers.
// ref: http://www.javascriptkit.com/javatutors/conditionalcompile.shtml
// NOTE: the Rhino compressor will (incorrectly?) remove the conditional!
// DO NOT COMPRESS THIS PAGE!
var isIE = false;
/*@cc_on
isIE = true;
@*/
var isMac = (navigator.platform.toLowerCase().indexOf('mac') > -1);


/**
* 
*/
function $(id){
    return (typeof id == 'string') ? document.getElementById(id) : id;
}

if (!Array.isArray){
    Array.prototype.isArray = true;
}


var timers = [];

/**
* 
*/
function clearAllTimers(){
    for (var i=0; i<timers.length; i++){
        if (timers[i]){
            clearTimeout(timers[i]);
        }
    }
}


function clearAll(){
    clearAllTimers();
    if (document.resetTutorialPageSecurity){
        document.resetTutorialPageSecurity(document);
    }
    if (document.resetClueframeSize){
        document.resetClueframeSize();
    }
    if (document.closeClueViewer){
        document.closeClueViewer();
    }

    setContent('title', '');
    setContent('info', '');
    setContent('instruc', '');
    setContent('content', '');
}

function setTimer(fn, delay){
    timers.push(setTimeout(fn, delay * 1000));
}

/**
* 
*/
function setContent(id, html, delay, evt){

    if (delay){
        setTimer(function(){
            setContent(id, html, 0, evt);
        }, delay);
    }
    else {
        var ele = $(id);
        ele.style.opacity = 0;
        ele.innerHTML = html;
        
        if (html){
            fadeIn(ele);
            //add events
            if (evt){
                if (typeof evt == "function"){
                    //just call this function
                    evt();
                }
                else if (evt.isArray){
                    for (var i=0; i<evt.length; i++){
                        var sEvt = evt[i];
                        addEvent(sEvt['id'], sEvt['name'], sEvt['func']);
                    }
                }
                else if (evt['id'].isArray){
                    for (var i=0; i<evt['id'].length; i++){
                        addEvent(evt['id'][i], evt['name'], evt['func']);
                    }
                }
                else {
                    addEvent(evt['id'], evt['name'], evt['func']);
                }
            }
        }
        else {
            ele.style.display = 'none';
        }
    }
}


/**
* 
*/
function addEvent(id, name, func){
    $(id)['on'+ name.toLowerCase()] = func;
}

function removeEvent(id, name){

    if (id.isArray){
        for (var i=0; i<id.length; i++){
            removeEvent(id[i], name);
        }
    }
    else {
        var ele = $(id);
        
        if (ele){
            ele['on'+ name.toLowerCase()] = null;
        }
    }
}


/**
* 
*/
function setOpacity(ele, opac){

    //~ if (isIE){
        //~ ele.style.filter = 'alpha(opacity='+ parseInt(opac * 100) +')';  

        //~ //save current opacity to element so we can retrieve it later (using getOpacity())
        //~ ele.styleOpacity = opac;
    //~ }
    //~ else {
        ele.style.opacity = opac;
    //~ }        
}

/**
* 
*/
function getOpacity(ele){

    //~ if (isIE){
        //~ return ele.styleOpacity ? ele.styleOpacity : 0;
    //~ }
    //~ else {
        return parseFloat(ele.style.opacity);
    //~ }
}

/**
* 
*/
function fadeIn(ele){
    
    if (!ele.innerHTML){
        return;
    }
    
    if (ele.style.display != 'block'){
        ele.style.display = 'block';
    }
    
    //IE can't handle opacity properly 
    if (isIE){return}
    
    var opac = (getOpacity(ele));
    
    opac += 0.1;
    if (opac >= 0.999){
        opac = 0.999;
        setOpacity(ele, opac);
    }
    else {
        setOpacity(ele, opac);
        setTimeout(function(){
            fadeIn(ele);
        }, 50);
    }
}

/**
* 
*/
function fadeOut(id){

    if (arguments.length > 1){
        for (var i=arguments.length-1; i>=0; i--){
            fadeOut(arguments[i]);
        }
    }
    else {
        var ele = $(id);
        
        if (!isIE){
            for (var i=10; i>=0; i--){
                setOpacity(ele, (i / 10));
            }
        }
        ele.style.display = 'none';
    }
}


/**
* 
*/
function selectMenuLink(id){
    var links = $('menu').getElementsByTagName('a');
    
    for (var i=0; i<links.length; i++){
        var link = links[i];
        if (link.id == 'menulink-'+ id){
            if (link.className.indexOf("selected") == -1){
                link.className += " selected";
            } 
        }
        else if (link.className.indexOf("selected") > -1){
            link.className = link.className.replace(/\s*selected\s*/, '');
        }
    }
}




var step = {};

step.start = function(){
    document.oninterclueinitdoc = function(){
    
        translate(document);
        removeEvent(document, 'interclueinitdoc');
        
        var page = (document.URL.indexOf("#") > -1) ? document.URL.replace(/^[^#]*#/, '') : '';
        if (page && step[page]){
            step[page]();
        } 
        else {
            step.welcome();
        }
    }
    
    
    if (document.interclueInitalized){
        document.oninterclueinitdoc();
    }
}


step.welcome = function(){
    clearAll();     
    selectMenuLink('welcome');    
    setContent('title', _('tutorial.welcome.title'));
    setContent('info', _('tutorial.welcome.info'), 1);
    setContent('instruc', _('tutorial.welcome.start.tutorial'), 2, {id : 'tutorial-next-step', name : 'click', func : step.linkscents});
}


step.linkscents = function(){
    clearAll();
    selectMenuLink('linkscents');
    setContent('instruc', _('tutorial.hover.mouse.over.link'));
    setContent('content', _('tutorial.link1'), 1, {id : 'link1', name : 'linkscentshow', func : step.showLinkscents});
}

step.showLinkscents = function(){
    clearAllTimers();
    removeEvent('link1', 'linkscentshow');
    addEvent('link1', 'clueframeshow', step.showClueFrame);
    fadeOut('title', 'info', 'instruc');
    setContent('title', _('tutorial.linkscent.title'), 1);
    setContent('info', _('tutorial.linkscent.info'), 2);
    
    setTimer(function(){
        $('link1').linkscent.disableClues = false;
    }, 3);
    
    setContent('instruc', _('tutorial.hover.mouse.over.linkscent'), 3);
}
 
step.showClueFrame = function(){
    clearAllTimers();
    removeEvent('link1', 'clueframeshow');
    fadeOut('title', 'info', 'instruc');
    setContent('title', _('tutorial.clueframe.title'), 1);
    
    setContent('info', _('tutorial.clueframe.info'), 2);
    //setContent('instruc', _('tutorial.move.mouse.off.link'), 3, {id:'link1', name:'clueframehide', func:step.nonHTML});
    setContent('instruc', _('tutorial.move.mouse.off.link'), 3, {id:'link1', name:'clueframehide', func:step.nextPrevButtons});
    
    //setContent('instruc', _('tutorial.clueframe.instruc.hide'), 5, {"id":"ClueFrame", "name":'resize', "func": step.resizeClueviewer});
}



step.nextPrevButtons = function(){
    clearAll();
    selectMenuLink('nextPrevButtons');
    setContent('title', _('tutorial.nextprevbuttons.title'), 1);
    setContent('info', _('tutorial.nextprevbuttons.info'), 2);
    setContent('instruc', _('tutorial.nextprevbuttons.instruc'), 3);
    setContent('content', _('tutorial.nextprevbuttons.content'), 3, {id : 'tutorial-next-step', name : 'click', func: step.enableDisableInterclue});
}

/*



step.nonHTML = function(){
    clearAll();
    selectMenuLink('nonHTML');
    setContent('instruc', _('tutorial.instruct.display.clueframe'), 1);
    setContent('content', _('tutorial.link2'), 2, {id : 'link2', name : 'clueframeshow', func : step.nonHTML1});
}

step.nonHTML1 = function(){
    clearAllTimers();
    removeEvent('link2', 'clueframeshow');
    addEvent('link2', 'clueframehide', step.cursors);
    fadeOut('title', 'info', 'instruc');
    setContent('title', _('tutorial.different.links.title'), 1);   
    setContent('info', _('tutorial.different.links.info'), 2);
    setContent('instruc', _('tutorial.clueframe.hide'), 3);
}

step.cursors = function(){
    clearAll();
    selectMenuLink('cursors');
    setContent('instruc', _('tutorial.hover.mouse.over.a.link'), 1);
    setContent('content', _('tutorial.cursors.links'), 2, {id : ['cursorLink1', 'cursorLink2', 'cursorLink3'], name : 'applycursors', func : step.cursors1});
}

step.cursors1 = function(){
    clearAllTimers();
    removeEvent(['cursorLink1', 'cursorLink2', 'cursorLink3'], 'applycursors');
    fadeOut('title', 'info', 'instruc');
    setContent('title', _('tutorial.mouse.cursors'), 1);
    setContent('info', _('tutorial.other.cursors.info'), 2);
    setContent('instruc', _('tutorial.click.to.continue'), 3, {id : 'tutorial-next-step', name : 'click', func: step.linkscentModes});
}



step.linkscentModes = function(){

    clearAll();
    selectMenuLink('linkscentModes');
    addEvent(document, 'changesecurityrule', step.linkscentModes2);
    fadeOut('title', 'info', 'instruc', 'content');
    setContent('title', _('tutorial.linkscentmodes.title'), 0);
    setContent('info', _('tutorial.linkscentmodes.info'), 1);
    setContent('instruc', _('tutorial.linkscentmodes.instruct'), 2);
}


step.linkscentModes2 = function(evt){

    var rule = (evt && evt.eventData && evt.eventData.rule) ? evt.eventData.rule : null;

    if (rule && rule.logic == "external"){
        removeEvent(document, 'changesecurityrule');
        step.options();
        //step.hotKey();
    }
}
*/
/*
step.hotKey = function(){
    
    clearAll();
    selectMenuLink('hotkey');
    
    //disable autolock...
    //Klib.Pref.set('ClueFrame.hotKey.autolockDelay', -1); 
    
    //to make sure the hotkey works we need to set the focus to this document.
    document.body.focus();
    
    document.interclueDisableAutolock = true;
    
    setContent('title', _('tutorial.hotkey.title'), 1); 
    setContent('info', _('tutorial.hotkey.info'), 2);
    
    setContent('content', _('tutorial.hotkey.link'), 2, {id : 'hotkeyLink', name : 'clueframeshow', func : step.hotKey2});

    setContent('instruc', _('tutorial.hotkey.instruc', {'hotKeyText': interclueHotKeyText()}), 3);
}

//~ step.hotKey1 = function(){

    //~ clearAllTimers();
    //~ removeEvent('link3', 'applycursors');
    
    //~ fadeOut('title', 'info', 'instruc');
    
    

    //~ setContent('title', _('tutorial.hotkey.title'), 1); 
    //~ setContent('info', _('tutorial.mouse.cursors.info'), 2);
    //~ setContent('instruc', _('tutorial.press.hotkey'), 5);
//~ }


step.hotKey2 = function(){
    clearAllTimers();
    removeEvent('hotkeyLink', 'clueframeshow');
    fadeOut('info', 'instruc');
    setContent('info', _('tutorial.hotkey.info2', {'hotKeyText': interclueHotKeyText()}), 2);
    setContent('instruc', _('tutorial.hotkey.instruc2', {'hotKeyText': interclueHotKeyText()}), 3, {id : 'ClueFrame', name : 'resize', func: step.resizeClueviewer});
}

//~ step.hideClueFrame = function(){
    //~ clearAllTimers();
    //~ removeEvent('link1', 'clueframeshow');
    //~ fadeOut('title', 'info', 'instruc');
    //~ setContent('title', _('tutorial.hiding.clueframe.title'), 1);
    //~ setContent('info', _('tutorial.clueframe.info.hide'), 2);
    //~ setContent('instruc', _('tutorial.move.mouse.off.link'), 5, {id:'link1', name:'clueframehide', func:step.nonHTML});
//~ }




step.resizeClueviewer = function(){
    clearAllTimers();
    removeEvent('hotkeyLink', 'resize');
    fadeOut('info', 'instruc');
    setContent('info', _('tutorial.clueframe.info.drag'), 2);
    setContent('instruc', _('tutorial.clueframe.instruc.drag'), 3, {"id":'ClueFrame', name:'dragfinish', func:step.dragClueviewer});
}

step.dragClueviewer = function(){
    clearAllTimers();
    removeEvent('ClueFrame', 'dragfinish');
    fadeOut('info', 'instruc');
    //setContent('title', _('tutorial.hotkey.close.title'), 1);
    setContent('info', _('tutorial.hotkey.close.info'), 2);
    setContent('instruc', _('tutorial.hotkey.close.instruc'), 3, {id:'hotkeyLink', name:'clueframehide', func:step.options});
}
*/

//

//~ step.lockedMode = function(){

    //~ //clearAll();
    //~ //selectMenuLink('lockedMode');

    //~ document.body.focus();
    //~ document.interclueDisableAutolock = false;
    
    //~ setContent('title', _('tutorial.lockedmode.title'), 1); 
    
    //~ setContent('content', _('tutorial.lockedmode.link1'), 2, {id : 'body', name : 'clueframelock', func : step.lockedMode1});

    //~ setContent('instruc', _('tutorial.lockedmode.instruc'), 4);
//~ }


//~ step.hotKey3 = function(){
    //~ clearAllTimers();
    //~ removeEvent('body', 'clueframelock');
    //~ fadeOut('info', 'instruc', 'title');
    //~ setContent('title', _('tutorial.hotkey.title3'));
    //~ setContent('info', _('tutorial.hotkey.info3'), 1);
    
    //~ //setContent('content', _('tutorial.hotkey.links3'), 1);
    
    //~ //setContent('instruc', _('tutorial.hotkey.instruc3', {'hotKeyText': interclueHotKeyText()}), 4, {id : 'body', name : 'clueframeunlock', func : step.options});

    //~ setContent('instruc', _('tutorial.click.to.continue'), 5, {id : 'tutorial-next-step', name : 'click', func: step.options});
//~ }


//~ step.lockedMode2 = function(){
    //~ clearAllTimers();
    //~ removeEvent(['lockedmodeLink1', 'lockedmodeLink2', 'lockedmodeLink3'], 'clueframeshow');
    
    //~ fadeOut('info', 'instruc');
    
    //~ setContent('info', _('tutorial.lockedmode.info2'), 2);
    //~ setContent('instruc', _('tutorial.lockedmode.instruc2'), 4, {id : 'body', name : 'clueframeunlock', func : step.linkscentModes});
//~ }


step.enableDisableInterclue = function(){
    clearAll();
    selectMenuLink('enableDisableInterclue'); 
    setContent('title', _('tutorial.enableDisableInterclue.title'), 0);
    setContent('info', _('tutorial.enableDisableInterclue.info'), 0);
    setContent('instruc', _('tutorial.click.to.continue'), 1, {id : 'tutorial-next-step', name : 'click', func: step.options});
}



step.options = function(){
    clearAll();
    selectMenuLink('options'); 
    setContent('title', _('tutorial.options.title'), 0);
    setContent('info', _('tutorial.options.info'), 0);
    initOptionLinks(document);
    setContent('instruc', _('tutorial.click.to.continue'), 1, {id : 'tutorial-next-step', name : 'click', func: step.finished});
}


step.finished = function(){
    clearAll();
    selectMenuLink('finished');    
    setContent('title', _('tutorial.finished.title'), 1);
    setContent('info', _('tutorial.finished.info'), 2);
    setContent('instruc', _('tutorial.click.to.finish'), 3, {id : 'tutorial-close', name : 'click', func: document.closeTab});
}


