
var interclue = window.interclue || {};

interclue.GUID = '{c33c5b47-69c8-45a4-a5e0-af85bbe628dd}';

interclue.isSiteHound = false;

interclue.isProfileDir = true;

interclue.servers = [];

interclue.servers.push({
    'name' : 'live',
    'url' : 'https://interclue.com',
    'icon' : 'chrome://interclue/skin/buttons/server.live.png'});

interclue.servers.push({
    'name' : 'local',
    'url' : 'http://localhost/interclue',
    'icon' : 'chrome://interclue/skin/buttons/server.local.png'});
    
interclue.servers.push({
    'name' : 'dev',
    'url' : 'http://dev.izeal.com/interclue.tabbed',
    'icon' : 'chrome://interclue/skin/buttons/server.dev.png'});
    

interclue.nextCall = '';


interclue.fixNoScript = function(url, enable){
    if (window.noscriptUtil){

        var ns = window.noscriptUtil.service;

        if (ns && ns.setJSEnabled){
            ns.setJSEnabled(url, enable);
        }
    }
}


interclue.registerStylesheet = function(href){
    //This code is from Conlan Wesson Link Alert v0.2
    //who got it from Raphael Jolivet's smart-cursor v0.2

    // Get Style Sheet service
    var sss = Components.classes["@mozilla.org/content/style-sheet-service;1"].getService(Components.interfaces.nsIStyleSheetService);
    // Get IO service
    var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
    // Build URI
    var uri = ios.newURI(href, null, null);
    // Register sheet
    sss.loadAndRegisterSheet(uri, sss.USER_SHEET);
}

interclue.unregisterStylesheet = function(href){
    var sss = Components.classes["@mozilla.org/content/style-sheet-service;1"].getService(Components.interfaces.nsIStyleSheetService);
    var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
    var uri = ios.newURI(href, null, null);
    sss.unregisterSheet(uri, sss.USER_SHEET);
}

interclue.inArray = function(needle, haystack){
    for (var i=0; i<haystack.length; i++){
        if (haystack[i] == needle){
            return true;
        }
    }
    return false;
}

/**
* load our scripts into the iframe
*/
interclue.initClueBridge = function(){

    if (!interclue.inArray("platform-firefox.js", interclue.scripts)){
        interclue.scripts.push("platform-firefox.js");
    }
    
    //scripts must be loaded using a file:// path 
    
    // SiteHound installs Interclue into the Browser/extensions directory.
    // however we install to the user's extension dir.
    var dirGetId = (interclue.isSiteHound) ? "CurProcD" : "ProfD";
    
    //however I like to keep sitehound away from my install directory.
    if (interclue.isProfileDir){
        dirGetId = "ProfD";
    }
    
    var dir = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get(dirGetId, Components.interfaces.nsILocalFile).path;
    var doc = document.getElementById('interclue-iframe').contentWindow.document;
    var fileUrl = "file:///"+ dir.replace(/\\\//g, '/') +"/extensions/" + interclue.GUID +"/chrome/interclue/content/cluecore/";
    
    interclue.fixNoScript('file:', true);

    for (var i=0; i<interclue.scripts.length; i++){
        interclue.addScript(fileUrl + interclue.scripts[i], doc);
    }
    
    interclue.fixNoScript('file:', false);
    
    interclue.initKlib();
}

/**
* 
*/
interclue.addScript = function(src, doc){
    doc = doc || document;
    var script = doc.createElement('script');
    script.src = src;
    script.type = 'text/javascript';
    try {
        doc.getElementsByTagName('head')[0].appendChild(script);
    }catch(e){
        doc.body.appendChild(script);
    }
}


interclue.initKlib = function(){
    var win = document.getElementById('interclue-iframe').contentWindow;

    if (win && win.Klib && win.Klib.init){
        
        win.Klib.init();
        
        if (interclue.nextCall){
            var code = interclue.nextCall;
            interclue.nextCall = '';
            
            var Klib = interclue.getKlib();
            eval(code);
        }
        //show ready image?
        win.Klib.Toolbar.refresh();
    }
    else {
        setTimeout(interclue.initKlib, 100);
    }
}


/**
* 
*/
interclue.call = function(code, event){

    //only activate on left click

    if (event && event.button == 2){return};

    var Klib = interclue.getKlib();
    
    if (Klib){
        eval(code);
    }
    else {
        interclue.nextCall = code;
        interclue.initClueBridge();
    }
}


interclue.getKlib = function(){
    var iframe = document.getElementById('interclue-iframe');
    
    if (iframe && iframe.contentWindow && iframe.contentWindow.Klib && iframe.contentWindow.Klib.initalized){
        return iframe.contentWindow.Klib;
    }
    else {
        return null;
    }
}



interclue.handleClose = function(){
    var Klib = interclue.getKlib();
    
    if (Klib){
        Klib.GEvent.fireLocal('windowclose');
    }
    
    gBrowser.removeEventListener("DOMContentLoaded", interclue.onBrowerDOMContentLoaded, false);
    window.removeEventListener('close', interclue.handleClose, true);
    window.removeEventListener('mousemove', interclue.handleMouseMove, true);
    interclue.Mouse.cleanup();
}

interclue.initalized = false;

interclue.init = function(){  

    if (gBrowser && !interclue.initalized){
        interclue.initalized = true;
        window.removeEventListener('load', interclue.init, true);
        
        interclue.setFirefoxVersionInfo();
        //no longer used, statusbar button only.
        //interclue.showToolbarButton('interclue-login-toolbarbutton');
        //interclue.showToolbarButton('interclue-logout-toolbarbutton', 'interclue-login-toolbarbutton');
        
        interclue.Mouse.init();
        interclue.Tooltip.init();
        
        gBrowser.addEventListener("DOMContentLoaded", interclue.onBrowerDOMContentLoaded, false);
        
        window.addEventListener('close', interclue.handleClose, true);
        //window.addEventListener('keydown', interclue.handleKeyDown, true);
        //window.addEventListener('keyup', interclue.handleKeyUp, true);
        //window.addEventListener('blur', interclue.handleKeyUp, true);
        
        window.addEventListener('mousemove', interclue.handleMouseMove, true);
        
        //prevent printing of clueframes/linkscents        
        interclue.registerStylesheet('chrome://interclue/content/linkscents.css');
        
        //cleanup unused preferences
        interclue.killPref("alltheclues");
        
        interclue.uninstallObserver.register();
        interclue.addEvent("uninstall-request", interclue.handleUninstallRequest);
        interclue.addEvent("uninstall-cancel", interclue.handleUninstallCancel);
        
        if (interclue.getPref("interclue.resetPrefs") === true){
            interclue.setPref("interclue.resetPrefs", false);
            interclue.setPref("interclue.preferences", '');
        }
        
        interclue.checkIfUpdated();
        
        //lets wait a moment and then do it
        //adding delay due to unknown browser crash at startup.
        //dont know why it's happening, but this appears to fix it.
        setTimeout(function(){
            document.getElementById('interclue-iframe').setAttribute('src', "chrome://interclue/content/cluecore/interclue.html");
        }, 2000);
        
        //send update ping 2 minutes after browser start
        interclue.updatePingTimer = setTimeout(interclue.updatePing, 2 * 60 * 1000);
        
        setTimeout(interclue.addAdblockExceptionRules, 2000);
    }
}


/**
* set firefox version info
*/
interclue.setFirefoxVersionInfo = function(){
    var verStr = interclue.getPref("extensions.lastAppVersion");
    if (verStr){
        var version = verStr.split(/\./g);
        interclue.FFVersion = {};
        interclue.FFVersion.major = parseInt(version[0]);
        interclue.FFVersion.minor = version[1] ? parseInt(version[1]) : 0;
        interclue.isFF2 = (interclue.FFVersion.major == 2);
        interclue.isFF3 = (interclue.FFVersion.major == 3);
    }
}
/**
* handle DOM loaded event
*/
interclue.onBrowerDOMContentLoaded = function(evt){
    //get the right document
    var doc = evt.originalTarget;
    
    if (doc && doc instanceof HTMLDocument){
        //good to go
        if (interclue.getPref("interclue.checkForEvilLinks", false)){
            interclue.checkPageForEvilLinks(doc);
        }
    }
}

/**
* inserts icons next to evil links on a page 
*/
interclue.checkPageForEvilLinks = function(doc){    
    var links = doc.getElementsByTagName("a");
    for (var i=0; i<links.length; i++){
        //need to send this to a separate function so the callback works correctly
        interclue.checkIfEvilLink(links[i]);     
    }
}

/**
* inserts an icon next to a link if it is evil
*/
interclue.checkIfEvilLink = function(link){

    var url = interclue.removeRedirects(link.href);

    //dont check invalid urls
    if (!interclue.urlToURI(url)){return}
    
    //or internal links
    if (interclue.isInternalLink(link)){return}
    
    interclue.isEvilURL(url, function(url, response){
    
        //make sure the link still exists.
        if (!link){return}
        
        var tables = (response) ? response.split(/\s*\,\s*/g) : [];
        for (var i=0; i<tables.length; i++){
            switch(tables[i]){
                case "goog-malware-shavar":
                    //is malware site.
                    //better mark this lin as evil.
                    link.setAttribute('interclue_link_type', 'malware');
                    //interclue.insertIcon(link, "chrome://interclue/skin/warning-malware.png", "WARNING: visiting this web site may harm your computer!");
                    break;
                    
                case "goog-phish-shavar":
                    //is phishing site
                    link.setAttribute('interclue_link_type', 'phish');
                    //interclue.insertIcon(link, "chrome://interclue/skin/warning-phishing.png", "WARNING: this site is thought to be a phishing (web forgery) scam");
                    break;
                
                case "":
                case null:
                    //link is safe
                    break;
                    
                default:
                    //unknown table name, assume it's evil.
                    interclue.logError(Error("Interclue: Unknown table name: ["+ response +"]"));
            }
        }
    })
}

/**
* inserts an icon directly after a link
*/
interclue.insertIcon = function(link, iconUrl, tooltip){
    var doc = link.ownerDocument;
    var img = doc.createElement("img");
    img.setAttribute("src", iconUrl);
    if (title){
        img.setAttribute("title", tooltip);
    }
    img.setAttribute("align", "bottom");
    img.setAttribute("border", "0");
    
    //we'll need to find this link if a user hovers over the icon.
    //img.link //doesn't work
    //just setting the same href will not work (their might be more than one link with the same url)
    img.setAttribute("interclue_link_href", link.href);
    var links = doc.getElementsByTagName('a');
    for (var i=0; i<links.length; i++){
        if (links[i] === link){
            img.setAttribute("interclue_link_index", i);
            break;
        }
    }
    
    //need to tell the linkscent positioner to adjust the linkscents position next to our image.
    link.setAttribute("interclue_linkclue_offset_x", "18");
    
    interclue.insertAfter(img, link);
}

/**
* inserts an element directly after another element in a DOM
*/
interclue.insertAfter = function(eleToInsert, ele){
    if (ele.nextSibling){
        ele.parentNode.insertBefore(eleToInsert, ele.nextSibling);
    }
    else {
        ele.parentNode.appendChild(eleToInsert);
    }
}

/**
* calls callback with 2 args, 1st arg is the url that as passed.
* 2nd arg is a comma separated string of tables to which the url belongs
* if url not found in any tables 2nd arg will be an empty string
* if url is invalid 2nd arg will be null.
*/
interclue.isEvilURL = function(url, callback){
    //check url, invalid urls (or urls with other protocols) will throw an error 
    //in FF2 phishWarden.isEvilURL().
    if (/^http(s)?:/i.test(url) && interclue.urlToURI(url)){
         
        //firefox 2 uses a safbrowsing object
        if (interclue.isFF2 && interclue.getPref("browser.safebrowsing.enabled", true) && !interclue.getPref("browser.safebrowsing.remoteLookups", false)){
         
            //firefox 2 uses a safebrowsing object to lookup urls
            //the safebrowsing.phishWarden is not enabled immediatly so we need to check if it's ready and active
            if (top.safebrowsing && top.safebrowsing.phishWarden && top.safebrowsing.phishWarden.isEvilURL){
                try {    
                    top.safebrowsing.phishWarden.isEvilURL(url, function(arg){
                        var IN_BLACKLIST = 0;
                        var IN_WHITELIST = 1;
                        var NOT_FOUND = 2;
                        //if found in blacklist AND whitelist then IN_WHITELIST will be returned
                        if (arg == IN_BLACKLIST){
                            //convert to FF3 is phishy info
                            callback(url, "goog-phish-shavar");
                        }
                        else {
                            callback(url, "");
                        }
                    });
                    return;
                }catch(e){}
            }
        }
        //firefox 3 uses something else
        else if (interclue.isFF3){
            var uri = interclue.urlToURI(url);
            if (uri && uri.spec && /^http(s)?:/.test(uri.spec)){
                //some urls (javascript: ) will throw a error if we try the lookup() on them.
                try {
                    var nsIUrlClass = Components.classes["@mozilla.org/url-classifier/dbservice;1"]
                        .getService(Components.interfaces.nsIUrlClassifierDBService);
                    nsIUrlClass.lookup(uri.spec, function(response){
                        callback(url, response);
                    });
                    return;
                    
                }catch(e){
                    //invalid URI?
                    interclue.logError(e);
                }
            }
        }
    }
    //if we get here something has gone wrong
    callback(url, null);
}



/**
* log an error to the error console
*/
interclue.logError = function(err){
    Components.utils.reportError(err); 
}

/**
* logs a message to the error console
*/
interclue.logMsg = function(msg){
    var str = "";
    for (var i=0; i<arguments.length; i++){
        str += arguments[i] + "\n";
    }
    
    var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
        .getService(Components.interfaces.nsIConsoleService);
    consoleService.logStringMessage("interclue:\n" + str);
}

interclue.addAdblockExceptionRules = function(){
    
    //adblockplus (easylist subscription) rightly blocks amazon affiliate adds.
    //but our summary of this type of link uses the amazon api to display info about the amazon product
    //by adding a unique string (interclue=1) to the api url and 
    //adding an exception rule we can display our summaries whilst still prevent normal adds from
    //being displayed.
    if (typeof abpTogglePattern == "function"){
        abpTogglePattern("@@http://rcm.amazon.com/e/cm?interclue*", true);     
        abpTogglePattern("@@http://rcm-images.amazon.com/images/*", true);     
    }
}

interclue.shutdown = function(evt){
    try {
        clearTimeout(interclue.updatePingTimer);
    }catch(e){}
    
    
    if (interclue.uninstallOnNextStart){
        //remove prefs on uninstall
        interclue.killPref("interclue");
        interclue.savePrefFile();
    }
}

interclue.savePrefFile = function(){
    var prefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    prefService.savePrefFile(null);
}

/**
* Flag to indicate if interclue will be uninstalled on browser restart 
*/
interclue.uninstallOnNextStart = false;

interclue.handleUninstallRequest = function(){

    //set a flag to indicate that interclue will be uninstalled
    interclue.uninstallOnNextStart = true;
    
    //open the nag url.
    var Klib = interclue.getKlib();
    
    if (Klib){
        var url = "http://interclue.com/uninstall.html"
        
        url = Klib.Url.add(url, "build", Klib.App.build);
        url = Klib.Url.add(url, "guid", Klib.User.getGuid());
        
        Klib.ClueBridge.openUrl(url, true, true, true);
    }
}


interclue.handleUninstallCancel = function(){
    interclue.uninstallOnNextStart = false;
}


//ref: http://xulsolutions.blogspot.com/2006/07/creating-uninstall-script-for.html
interclue.uninstallObserver = {
    
    //flag to tell if item is to be uninstalled at next restart.
    _uninstall : false,
    
    //handle observe event
    observe : function(subject, topic, data) {
        //action called
        if (topic == "em-action-requested") {
            subject.QueryInterface(Components.interfaces.nsIUpdateItem);

            if (subject.id == interclue.GUID) {
                //add-on being marked for uninstall
                if (data == "item-uninstalled") {
                    this._uninstall = true;
                    interclue.fireEvent("uninstall-request");
                } 
                //cancel uninstall
                else if (data == "item-cancel-action") {
                    this._uninstall = false;
                    interclue.fireEvent("uninstall-cancel");
                }
            }
        } 
        //browser is closing
        else if (topic == "quit-application-granted") {
            if (this._uninstall) {
                /* uninstall stuff. */
                interclue.fireEvent("uninstall");
            }
            this.unregister();
        }
    },
    
    //start observing
    register : function() {
        var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
        observerService.addObserver(this, "em-action-requested", false);
        observerService.addObserver(this, "quit-application-granted", false);
    },
    
    //stop observing
    unregister : function() {
        var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
        observerService.removeObserver(this,"em-action-requested");
        observerService.removeObserver(this,"quit-application-granted");
    }
}

interclue.handleMouseMove = function(evt){
    //set a flag to say if the mouse currently over an html document.
    var t = evt.target;
    
    interclue.isMouseOverHTMLDoc = (t && t.nodeName && t.getAttribute && t.nodeName == 'tabbrowser' && t.getAttribute('id') == 'content');
}


interclue.showToolbarButton = function(id, insertAfter){

    var navbar = document.getElementById('nav-bar');
    var buttons = (navbar.currentSet) ? navbar.currentSet : navbar.defaultSet;

    if (buttons.indexOf(id) == -1){

        var set = buttons.split(/\s*,\s*/g);
        var newSet = [];
        var inserted = false;
        
        for (var i=0; i<set.length; i++){
            newSet.push(set[i]);
            if (insertAfter && set[i] == insertAfter){
                newSet.push(id);
                inserted = true;
            }
        }
        
        if (!inserted){
            newSet.push(id);
        }
        newSet = newSet.join(','); 
        navbar.currentSet = newSet;
        navbar.setAttribute('currentset', newSet);
        
        //save the changes
        document.persist("nav-bar","currentset"); 
    }
}


interclue.initPref = function(name, initValue){
    if (interclue.getPref(name, null) === null){
        interclue.setPref(name, initValue);
        return true;
    }
    else {
        return false;
    }
}


/**
* 
*/
interclue.getPref = function(name, defaultVal){
    try{
        var branch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
        switch (branch.getPrefType(name)){
            case 32 : //string
                return  branch.getCharPref(name);
            case 64 : //int
                return branch.getIntPref(name);
            case 128: //bool
                return branch.getBoolPref(name);
        }
    
    }catch(e){}

    return defaultVal;
}

interclue.setPref = function(name, val){

    //dont set prefs if we are about to uninstall the add-on
    if (interclue.uninstallOnNextStart){return};

    var branch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
    
    if ((val === true) || (val === false)){
        branch.setBoolPref(name, val);
    }
    else if (typeof val == 'string'){
        branch.setCharPref(name, val);
    }
    else {
        branch.setIntPref(name, val);
    }
}


interclue.killPref = function(name){
    var branch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
    branch.deleteBranch(name);
}


//~ interclue.restart = function(event){
    //~ if (event && event.button == 2){return};
    //~ var startup = Components.interfaces.nsIAppStartup;
    //~ Components.classes["@mozilla.org/toolkit/app-startup;1"].getService(startup).quit(startup.eRestart | startup.eAttemptQuit);
//~ }


//~ interclue.handleKeyDown = function(evt){

    //~ if (!interclue.keydown){
        //~ interclue.keydown = true;
        
        //~ var Klib = interclue.getKlib();
        //~ if (Klib && Klib.User.winLoggedIn){
            //~ Klib.Clue.handleHotKeys(evt);
        //~ }
    //~ }
//~ }

//~ interclue.handleKeyUp = function(evt){
    //~ interclue.keydown = false;
    
    //~ var Klib = interclue.getKlib();
    //~ if (Klib && Klib.User.winLoggedIn){
        //~ Klib.Clue.fireHotKeyOff();
    //~ }
//~ }

interclue.events = {};

interclue.addEvent = function(evtName, func){
    interclue.events[evtName] = interclue.events[evtName] || [];
    interclue.events[evtName].push(func);
}

interclue.removeEvent = function(evtName, func){

    if (interclue.events[evtName] && interclue.events[evtName].length){
        var evts = [];
        for (var i=0; i<interclue.events[evtName].length; i++){
            if (interclue.events[evtName][i] != func){
                evts.push(interclue.events[evtName][i]);
            }
        }
        interclue.events[evtName] = evts;
    }
}

interclue.fireEvent = function(evtName, args){
    interclue.events[evtName] = interclue.events[evtName] || [];
    for (var i=0; i<interclue.events[evtName].length; i++){
        interclue.events[evtName][i](args);
    }
}

//hash table of hints that have already been viewed.
interclue.hintsShown = {};

interclue.showHint = function(popupId, ele, imageURL, tutorialPage, x, y){
    //can either be called with showHint(id, ele, [tooltipposition])
    //of showHint(id, x, y, [tooltipposition]) 
    
    //would normally use boxObject to get dimentions but hintBox is collapsed so width & height are 0. 
    var HINT_BOX_WIDTH = 354;
    var HINT_BOX_HEIGHT = 219;
    //perhaps it would be better to check the height and width after the first time it is viewed?
    //maybe make it hidden and but not collapsed, then get the dimentions?
    //for now am cheating
    
    var Klib = interclue.getKlib();
    
    //are we supposed to be showing this hint?
    if (!interclue.hintsShown[popupId] && interclue.getKlib().Pref.get("hint."+ popupId +".show")){
        interclue.hintsShown[popupId] = true;
        
        var popup = document.getElementById('interclue-hint-popup');
        popup.popupId = popupId;
        //set the message title, and text
        document.getElementById('interclue-hint-title').value = Klib.string("hint."+ popupId +".title");
        document.getElementById('interclue-hint-text').firstChild.data = Klib.string("hint."+ popupId +".text");
        document.getElementById('interclue-hint-checkbox-dontshowagain').checked = false;
        document.getElementById('interclue-hint-title-image').src = imageURL ? imageURL : '';
        document.getElementById('interclue-hint-title-image').collapsed = imageURL ? false : true;
        
        var link = document.getElementById('interclue-hint-link');
        if (tutorialPage){    
            link.tutorialPage = tutorialPage; 
            //link.setAttribute("value", Klib.string("hint.link.text"));
            link.collapsed = false;
        }
        else {
            link.collapsed = true;
        }
        //show hint
        var browserBox = document.getElementById('main-window').boxObject;
        
        //position relative to an element?
        if (ele){
            
            //choose the correct location for the popup depending on the elements location relative to the browser window
            var eleBox = ele.ownerDocument.getBoxObjectFor(ele);
            
            x = eleBox.screenX;
            y = eleBox.screenY;
                
            //use tooltip positioning
            //http://www.bekkoame.ne.jp/~poetlabo/WWW/XULref/common.html
            
            //where popup content should be anchored on the element
            //popupanchor="none | topleft | topright | bottomleft | bottomright" 
            
            //which side of the popup content should be attached to the popupanchor. 
            //popupalign="none | topleft | topright | bottomleft | bottomright" 
            
            
            //popup.showPopup(document.getElementById("interclue-statusbarpanel"), x, y, "popup", popupanchor, popupalign);
        }
        
        //position the hint box.
        var hor = ((x + HINT_BOX_WIDTH) >= (browserBox.screenX + browserBox.width)) ? "right" : "left";
        var ver = ((y + HINT_BOX_HEIGHT) >= (browserBox.screenY + browserBox.height)) ? "bottom" : "top";
        
        //adjust for direction and drop shadow
        if (hor == "right"){
            x -= HINT_BOX_WIDTH;
            x += 10;
        }
        if (ver == "bottom"){
            y -= HINT_BOX_HEIGHT;
            y += 10;
        }
        popup.className = "interclue-hint-"+ ver +"-"+ hor;
        
        //adjust spacers 
        document.getElementById("interclue-hint-popup-spacer-top").setAttribute("height", (ver == "bottom") ? 8 : 37); 
        document.getElementById("interclue-hint-popup-spacer-bottom").setAttribute("height", (ver == "bottom") ? 37 : 8); 
        
        //show the popup
        popup.showPopup(document.getElementById("interclue-statusbarpanel"), x, y, "popup", null, null);
    }
}

interclue.closeHint = function(){

    var popup = document.getElementById('interclue-hint-popup');
    popup.hidePopup();
    
    if (document.getElementById('interclue-hint-checkbox-dontshowagain').checked){
        var popupId = popup.popupId;
        //and save into prefs.
        interclue.getKlib().Pref.set("hint."+ popupId +".show", false);
    }
}

interclue.showTutorialPage = function(page){
    var Klib = interclue.getKlib();
    Klib.Tutorial.showTutorial(page);
    interclue.closeHint();
}

/**
* once a day ping the update server.
*/
interclue.updatePing = function(){
    
    var Klib = interclue.getKlib();
    
    if (Klib){
        Klib.Update.checkForUpdates();
        //try again tomorrow (in case the user likes to keep firefox running for more than 24 hours at a time).
        interclue.updatePingTimer = setTimeout(interclue.updatePing, 24 * 60 * 60 * 1000);    
    }
    else {
        //Klib not initalized, try again in 5 minutes.
        interclue.updatePingTimer = setTimeout(interclue.updatePing, 5 * 60 * 1000);    
    }
}

interclue.enable = function(){
    interclue.call("Klib.ClueBridge.setState('enabled')");
}
interclue.disableDomain = function(){
    interclue.call("Klib.ClueBridge.setState('disabled-for-domain')");
}
interclue.disableUntilRestart = function(){
    interclue.call("Klib.ClueBridge.setState('disabled-until-restart')");
}
interclue.disable = function(){
    interclue.call("Klib.ClueBridge.setState('disabled')");
}

/**
* read a value from the registry
*/
interclue.getRegistryValue = function(key){
    
    var wrk = Components.classes["@mozilla.org/windows-registry-key;1"].createInstance(Components.interfaces.nsIWindowsRegKey);
    
    //accept slashes and backslashes
    key = key.replace(/[\\\/]+/g, '\\');
    
    //split the key into root/path/node segments
    var m = key.match(/^([^\\]+)\\(.+)\\([^\\]+)$/);
    
    if (m){
        var root = m[1].toUpperCase();
        var path = m[2];
        var node = m[3];
        var rootNode;
        
        switch (root){
            case "HKCR": 
            case "HKEY_CLASSES_ROOT":
                rootNode = wrk.ROOT_KEY_CLASSES_ROOT;
                break;
                
            case "HKCU": 
            case "HKEY_CURRENT_USER":
                rootNode = wrk.ROOT_KEY_CURRENT_USER;
                break;
            
            case "HKLM": 
            case "HKEY_LOCAL_MACHINE":
                rootNode = wrk.ROOT_KEY_LOCAL_MACHINE;
                break;
            
            default:
                throw Error("Interclue:registry: Invalid root node ["+ root +"]");
        }
        
        //path needs to have backslashes (\) escaped.
        
        try {
            wrk.open(rootNode, path, wrk.ACCESS_READ);
        }catch(e){
            //Failed, assume key doesn't exist?
            return null;
        }
        
        var val;
        switch (wrk.getValueType(node)) {
            case wrk.TYPE_STRING:
                val = wrk.readStringValue(node);
                break;
            case wrk.TYPE_BINARY:
                val = wrk.readBinaryValue(node);
                break;
            case wrk.TYPE_INT:
                val = wrk.readIntValue(node);
                break;
            case wrk.TYPE_INT64:
                val = wrk.readInt64Value(node);
                break;
            default:
                val = null;
        }
        wrk.close();
        return val;
    }
    else {
        throw Error("Invalid registry path ["+ key +"]");
    }
}

/**
* return the current Operating System 
* returns "WINNT" on Windows Vista, XP, 2000, and NT systems
* and returns "Linux" on GNU/Linux
*/
interclue.getOS = function(){
    return Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime).OS;
}

/**
* return TRUE is operating system is Windows based (NT, 2000, XP, Vista)
*/
interclue.isWindows = function(){
    return (interclue.getOS() == "WINNT");
}

/**
* return TRUE is file exists
*/
interclue.fileExists = function(path){
    var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
    file.initWithPath(path);
    return file.exists();
}

/**
* creates a temporary file and writes the given data to it
* returns the path to the temporary file
*/
interclue.writeTempFile = function(data){
    var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("TmpD", Components.interfaces.nsIFile);
    file.append("interclue.tmp");
    file.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0666);
    
    // file is nsIFile, data is a string
    var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
    
    // use 0x02 | 0x10 to open file for appending.
    foStream.init(file, 0x02 | 0x08 | 0x20, 0666, 0); 
    // write, create, truncate
    //In a c file operation, we have no need to set file mode with or operation, 
    //directly using "r" or "w" usually.
    foStream.write(data, data.length);
    foStream.close();

    return file.path;
}




/**
* Executes a command as if it were entered onto the command line
*  @fullPathToExe: string : full path to executable to call (eg "c:\windows\notepad.exe")
*  @args: array : Array of command line arguments to add (eg ["/new",  "--help"])?
*/
interclue.exec = function(fullPathToExe, args, waitOnReturn){
    
    var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
    file.initWithPath(fullPathToExe);

    var process = Components.classes["@mozilla.org/process/util;1"].createInstance(Components.interfaces.nsIProcess);
    process.init(file);

    // Run the process.
    var wait = waitOnReturn ? true : false;
    process.run(wait, args, args.length);
}

/**
* 
*/
interclue.checkIfUpdated = function(){
    var Klib = interclue.getKlib();
    
    if (Klib){
        Klib.Update.runUpdateScripts();
    }
    else {
        //try again in a moment
        setTimeout(interclue.checkIfUpdated , 2000)
    }
}

/**
* return the zoom level of the currently visible (focused) document in FF3
* returns 0 if zoom level is unavailable (FF < 3)
*/
interclue.getCurrentDocZoomLevel = function(){
    var level = getBrowser().mCurrentBrowser.markupDocumentViewer.fullZoom;
    return (typeof level == "number") ? level : 1;
}

/**
* converts a URL string to a URI that is used in many firefox functions

== example URI returned from "http://www.mozilla.com/en-US/" ==

spec=http://www.mozilla.com/en-US/
prePath=http://www.mozilla.com
scheme=http
userPass=
username=
password=
hostPort=www.mozilla.com
host=www.mozilla.com
port=-1
path=/en-US/
*/

interclue.urlToURI = function(url){
    try {
        return Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService).newURI(url, null, null);
    }catch(e){
        return null;
    }
}


/**
* keep track of where the mouse is over our browser
*/
interclue.Mouse = {};
interclue.Mouse.screenX = 0;
interclue.Mouse.screenY = 0;
interclue.Mouse.init = function(){
    window.addEventListener("mousemove", interclue.Mouse.onMouseMove, false);
}
interclue.Mouse.cleanup = function(){
    window.removeEventListener("mousemove", interclue.Mouse.onMouseMove, false);
}
interclue.Mouse.onMouseMove = function(evt){
    interclue.Mouse.screenX = evt.screenX;
    interclue.Mouse.screenY = evt.screenY;
}


/**
* the interclue tooltip
*/
interclue.Tooltip = {}
interclue.Tooltip.init = function(){
    //attach functions to the tooltip object
    var tooltip = document.getElementById("interclue-tooltip");
    tooltip.startHideTimer = interclue.Tooltip.startHideTimer;
    tooltip.stopHideTimer = interclue.Tooltip.stopHideTimer;
}
/**
* starts the hide timer
*/
interclue.Tooltip.startHideTimer = function(){

    var tooltip = document.getElementById("interclue-tooltip");
    var delay = parseInt(tooltip.getAttribute("hidedelay"));
    tooltip.stopHideTimer();
    tooltip.hideTimer = setTimeout(function(){
        tooltip.hidePopup()
    }, 4000);
}
/**
* stop the hide timer
* NOTE: this doesn't work in FF2, any attempt to move the mouse over the tooltip will hide it!
*/
interclue.Tooltip.stopHideTimer = function(){
    var tooltip = document.getElementById("interclue-tooltip");
    if (tooltip.hideTimer){
        clearTimeout(tooltip.hideTimer);
    }
}
/**
* shows the tooltip
*/
interclue.Tooltip.show = function(text, screenX, screenY){
    //set the text of the tooltip
    var desc = document.getElementById("interclue-tooltip-description");
    if (desc.firstChild && desc.firstChild.nodeType == 3){
        desc.firstChild.data = text;
    }
    else {
        var textnode = document.createTextNode(text);
        desc.appendChild(textnode);
    }  
    //and show the tooltip
    screenX = screenX || interclue.Mouse.screenX;
    screenY = screenY || interclue.Mouse.screenY;
    
    //have to put this in a timer here, 
    //otherwise the tooltip just doesn't show, dont know why?
    setTimeout(function(){
        var tooltip = document.getElementById("interclue-tooltip");
        tooltip.text = text;
        if (typeof tooltip.openPopupAtScreen == "function"){
            tooltip.openPopupAtScreen(screenX, screenY);
        }
        //FF2 doesn't support openPopupAtScreen
        else {
            //use tooltip positioning
            //http://www.bekkoame.ne.jp/~poetlabo/WWW/XULref/common.html
            
            //where popup content should be anchored on the element
            //popupanchor="none | topleft | topright | bottomleft | bottomright" 
            
            //which side of the popup content should be attached to the popupanchor. 
            //popupalign="none | topleft | topright | bottomleft | bottomright" 
            
            tooltip.showPopup(document.getElementById("main-window"), screenX, screenY, "tooltip", "bottomleft", "bottomleft");
        }
    }, 50);   
}


interclue.redirects = {};
interclue.redirects["google"] = function(url){
    //check for google redirections
    var m = url.match(/^http:\/\/[^\.]+.google.[^\/]+\/interstitial\?url=([^&]+)/i);
    return m ? decodeURIComponent(m[1]) : url;
}

/**
* removes known redirects from a url
*/
interclue.removeRedirects = function(url){
    //assume each redirect will only occur once
    for(var id in interclue.redirects){
        url = interclue.redirects[id](url);
    }
    return url;
}

/**
* return TRUE if link points to the same domain as the page it is on.
*/
interclue.isInternalLink = function(link){
    var docURI = interclue.urlToURI(link.ownerDocument.URL);
    var linkURL = interclue.removeRedirects(link.href);
    var linkURI = interclue.urlToURI(linkURL);
    
    return (docURI && linkURI && docURI.host && docURI.scheme && docURI.scheme == linkURI.scheme && docURI.host == linkURI.host);
}

/**
* duh
*/


window.addEventListener('load', interclue.init, true);
window.addEventListener('close', interclue.shutdown, true);
